#Copyright (c) 2018 Vereign AG [https://www.vereign.com]
#
#This is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as
#published by the Free Software Foundation, either version 3 of the
#License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.
#
#You should have received a copy of the GNU Affero General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#http://localhost:8081/policy
#Author: Georgi Michev georgi.michev@vereign.com

@rest @all @tsa @policy
Feature: As user
  I want to evaluate the policy
  So I am able to execute it in the future

  Acceptance criteria:
  - HTTP endpoint to evaluate the policy
  - example policy created and committed to Git repo
  - Green test based on example committed to the system

  Background:
    Given we are testing the TSA Policy Api
#    And I upload the policy to repository

  Scenario: TSA - Evaluate policy synchronously - Positive
    Given I upload a policy {test1} to repository
    And set the policy to productive
    And the policy successfully uploaded to the system
    Then I load the REST request {Policy.json} with profile {successful_evaluate}
    And I execute the policy {/testable/test1/2.0/evaluation}
    Then the status code should be {200}
    And the response is valid according to the {Policy_Evaluate_schema.json} REST schema
    And the field {allow} has the value {true}
    And the field {taskID} has the value {0123456}
    And delete policy {test1} from repository

  @test
  Scenario: TSA - DID resolution - Positive
    Given I upload a DID resolver policy to repository
    Then I load the REST request {Policy.json} with profile {didResolve_evaluate}
    And I execute the policy {/example/resolve/1.0/evaluation}
    Then the status code should be {200}
    And the response is valid according to the {Policy_EvaluateDID_schema.json} REST schema
    And the field {data.didDocument.id} has the value {did:indy:idunion:BDrEcHc8Tb4Lb2VyQZWEDE}
    And the field {taskID} has the value {01234567}
    And delete policy {resolve} from repository

  Scenario: TSA - Evaluate policy synchronously - Negative
    Given I upload a policy {test6} to repository
    And set the policy to productive
    And the policy successfully uploaded to the system
    Then I load the REST request {Policy.json} with profile {unsuccessful_evaluate}
    And I execute the policy {/testable/test6/2.0/evaluation}
    Then the status code should be {200}
    And the response is valid according to the {Policy_Evaluate_schema.json} REST schema
    And the field {allow} has the value {false}
    And the field {taskID} has the value {0123456}
    And delete policy {test6} from repository