#Copyright (c) 2018 Vereign AG [https://www.vereign.com]
#
#This is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as
#published by the Free Software Foundation, either version 3 of the
#License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.
#
#You should have received a copy of the GNU Affero General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#http://localhost:8081/policy
#Author: Georgi Michev georgi.michev@vereign.com

@rest @all @tsa @policy @lock
Feature: As user
  I want to unlock a policy
  So I can evaluate it

  Background:
    Given we are testing the TSA Policy Api
#    And I upload the policy to repository

  Scenario: TSA - Unlock policy - Positive
    Given I upload a policy {test4} to repository
    When I lock the policy {/testable/test4/2.0/lock}
    And I unlock the policy {/testable/test4/2.0/lock}
    And the status code should be {200}
    And delete policy {test4} from repository

  Scenario: TSA - Unlock already unlocked policy - Negative
    Given I upload a policy {test5} to repository
    When I unlock the policy {/testable/test5/2.0/lock}
    And I unlock the policy {/testable/test5/2.0/lock}
    And the status code should be {403}
    And the field {message} has the value {policy is unlocked}
    And delete policy {test5} from repository
